// we are including all the PM header files here.  Please replace with you
// stock "Include all the OS/2 PM stuff" include file
#define INCL_WIN
#define INCL_DOS
#define INCL_DOSDEVIOCTL

#define INCL_RXFUNC
#define INCL_RXARI

extern "C"
{
#include <os2.h>
#include <rexxsaa.h>
}

// include the Mesa AddIn header file
#include "extaddin.h"
#include <string.h>
#include <stdio.h>                 // added for printf
#include <stdlib.h>
#include <math.h>


#include "model.h"
#include "range.h"
#include "solver.h"
#include "addin.h"
#include "data.h"

extern AddIn *thisAddIn;

static void stuffRXString(RXSTRING *rxs,const char *s)
{
    int len = strlen(s);

    // if we're too long, give me some space
    if (len > 250)
        DosAllocMem((PPVOID) &(rxs -> strptr),len + 10,PAG_COMMIT | PAG_READ | PAG_WRITE);

    rxs -> strlength = len;
    if (!len) {
        strcpy((char *) rxs -> strptr,"");
    } else {
        strcpy((char *) rxs -> strptr,s);
    } // endif
}


static int done = 0;
int _System waitForInput(void * model_handle,int layer,int row,
                         int column,const char *data)
{
    done = 1;
    return 0;
}

// template for a new REXX function
LONG EXPENTRY waitForIntputRexxFunc(PSZ rexxName,LONG rexxArgc,RXSTRING *rexxArgv,
                       PSZ queuename,PRXSTRING rexxRet)
{
    LONG rexxRetLong = 0;
    int error = 0;

    if (rexxArgc != 0) {
        rexxRetLong = 40;
        stuffRXString(rexxRet,"0");
    } else {
        thisAddIn -> registerDataEnteredFunction(waitForInput);
        done = 0;
        WinPostMsg(thisAddIn -> getApplicationWindow(),WM_COMMAND,(MPARAM)0x133d,0);
        while (!done) {
            DosSleep(10);
            if (!done && !thisAddIn -> isEditing()) {
                done = 1;
                error = 1;
            } else if (done && thisAddIn -> isEditing()) {
                // done, but still editing.  must have had an error
                done = 0;
            }
        } // endwhile
        done = 0;
        thisAddIn -> registerDataEnteredFunction(NULL);
    }

    stuffRXString(rexxRet,error?"0":"1");
    return rexxRetLong;
}



LONG EXPENTRY dataFilterRexxFunc(PSZ rexxName,LONG rexxArgc,RXSTRING *rexxArgv,
                       PSZ queuename,PRXSTRING rexxRet)
{
    LONG rexxRetLong = 0;
    int error = 0;

    if (rexxArgc != 3) {
        rexxRetLong = 40;
        stuffRXString(rexxRet,"0");
    } else {
        Model model(-1);
        DataFilter filter(&model,thisAddIn -> getActiveWindow());

        filter.setTable(model.stringToRange(rexxArgv[0].strptr));
        filter.setCriteria(model.stringToRange(rexxArgv[1].strptr));
        filter.setOutput(model.stringToRange(rexxArgv[2].strptr));
        error = filter.doFilter2();
    }

    stuffRXString(rexxRet,error?"0":"1");
    return rexxRetLong;
}

